package prowas3

import groovy.swing.SwingBuilder
import groovy.transform.Immutable

import java.awt.Color
import java.awt.Graphics
import java.awt.event.MouseEvent
import java.awt.event.MouseListener

import javax.swing.JFrame
import javax.swing.JPanel


// groovy Render.groovy [specs]


def input = args.size() > 0 ? args[0] : "vzorova_zadani/specifikace-24.63"

def tower = new File(input).text.split("\n")

def dsp = new DisplayTower(cubes: tower)

def usedc = [:]
tower[1..-1].each {
	def spl = it.split(/[\sXx]+/).grep { it } // Fixes Windows endlines
	def c = new UsedCube(color: spl[3], width: spl[4] as int, height: spl[5] as int)
	if(!usedc[c])
		usedc[c] = 0
	usedc[c]++
}

SwingBuilder.edtBuilder {
	frame(show: true, defaultCloseOperation: JFrame.EXIT_ON_CLOSE, size: [1200, 1000]) {
		widget(dsp, size: [600, 600])
	}
}

class DisplayTower extends JPanel {
	
	static final COLORS = 
		["A": new Color(0, 255, 255),
		"R": new Color(255, 0, 0),
		"G": new Color(0, 255, 0),
		"B": new Color(0, 0, 255),
		"Y": new Color(255, 255, 0)]
	
	def cubes
	def floor = 1
	int scale = 40
	
	public DisplayTower() {
		def self = this
		this.addMouseListener(new MouseListener() {
			void mouseEntered(MouseEvent me) {};
			void mouseExited(MouseEvent me) {};
			void mouseClicked(MouseEvent me) {};
			void mouseReleased(MouseEvent me) {};
			void mousePressed(MouseEvent me) {
				if(me.button == 1)
					floor++
				else if(me.button == 3 && floor > 0)
					floor--
				else
					return // No need to repaint
				self.repaint()
			};
		})
	}
	
	void paint(Graphics g) {
		g.color = Color.LIGHT_GRAY
		g.fillRect(0, 0, this.width, this.height)
		cubes[1..-1].each {
			def spl = it.split(/[\sXx]+/).grep { it } // Fixes Windows endlines
			if(spl[0] as int != floor)
				return
			int cx = (spl[1] as int) * scale
			int cy = (spl[2] as int) * scale
			int cw = (spl[4] as int) * scale
			int ch = (spl[5] as int) * scale
			g.color = COLORS[spl[3]]
			g.fillRect(cx, cy, cw, ch)
			g.color = Color.BLACK
			g.drawRect(cx, cy, cw, ch)
		}
	}
}

@Immutable
class UsedCube { // Basically Cube, but with autogenerated .equals etc
	String color
	int width
	int height
}